/**
 * Confrontation section of Varanar, Night Two.
 * @param {NightTwoController} controller The Night Two controller.
 */
function NightTwoLewdAppease(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reluctantId = arguments.callee.name + "ButtonOne";
    var eagerId = arguments.callee.name + "ButtonTwo";
    var unfitId = arguments.callee.name + "ButtonThree";

    var toReluctant = new NightTwoLewdReluctant(ctrl);
    var toEager = new NightTwoLewdEager(ctrl);
    var toUnfit = new NightTwoLewdUnfit(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            No matter what you say, they'll find a way to turn it against you,
                            but if you don't play along, you doubt things would end well.
                            If you just give them the laugh they're after, you're certain they'll leave you alone.
                            Besides, if you show the group that you can take a [i]joke[/i] just as well as any human can,
                            perhaps they'll get bored and find a different target to pick on.
                        [/p]
                        [p]
                            Forsaking your pride, you half-heartedly stammer out that yes, kobolds are [i]indeed[/i] good at [b]sucking human cock[/b].
                            You can barely even get those final three words past your lips, your mind screaming at you [b]not[/b] to put yourself down like this.
                            But, in a way, the statement isn't even [i]wrong[/i].
                            While most kobolds are [i]scoundrels[/i] of some form or another, the ones that aren't tend to be [b]prostitutes[/b],
                            relying on innate [b]tightness[/b] due to size difference, and a knack for shoving things down their throats without gagging or retching.
                            In that sense: yes. Your kind [i]is[/i] good at [b]giving blowjobs[/b].
                        [/p]
                        [p]
                            The entire group bursts out into laughter at the sight of a kobold humiliating itself.
                            The drunken men begin to taunt you anew, although the mood is slightly more cheerful now than it was before,
                            their insults clearly less meant to [b]hurt[/b] you this time around.
                            It seems as though your gamble has paid off.
                        [/p]
                        [p]
                            One of the men still seems displeased.
                            As the posse begins to quiet down, he raises his voice:
                            "[color=green]Kobolds are [b]liars[/b].
                            Who knows if this one is telling the truth?!
                            Make'em [b]prove[/b] it![/color]"
                            At first, the group pays the dissenter no mind.
                            Slowly, but steadily, however, cogs begin to turn inside of their drunken heads.
                            As they come to a communal conclusion, some of the men begin to voice their response in unison:
                            "[color=purple]Yeah. Make'em prove it![/color]"
                            "[color=brown]The kobold lies![/color]"
                            "[color=dred]Put on a show![/color]"
                        [/p]
                        [p]
                            The man in front of you realizes he's losing the crowd's favour.
                            A grin forms atop his visage.
                            "[color=bred]Audric's right.[/color]" he speaks, his hands travelling down to his waist, resting atop his belt buckle.
                            "[color=bred]You lizards are a bunch of liars.[/color]"
                            He unfastens the clasp sealing the leather cord, his pants visible loosening.
                            "[color=bred]And we don't take kindly to liars around these parts.[/color]"
                            That being said, the drunkard promptly lowers his pants and his underwear,
                            his flaccid, uncut member surrounded with a hefty amount of pubic hair
                            "[color=bred]Let's see if you were telling the truth or not.[/color]"
                        [/p]
                        [p]
                            The entire group seems riled up.
                            They [b]really[/b] want this to happen, and judging by the exposed human's tone,
                            you're in too deep to back out now.
                            Unless you can present a strong case for yourself, you fear this [b]is[/b] happening.
                            That doesn't mean you need to like it, though.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildReluctantChoice() {
        var disabled = ctrl.appease.has() ? "disabled" : "";
        var isSelected = ctrl.appease.get() === NightTwoLewdAppeaseChoice.RELUCTANT;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${reluctantId}" ${disabled}>Reluctant</button>`;

        var tooltip = global.parser.parse(`You don't really want to participate in these guys' debauchery, but you don't have much of a choice.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 185px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildEagerChoice() {
        var disabled = ctrl.appease.has() ? "disabled" : "";
        var isSelected = ctrl.appease.get() === NightTwoLewdAppeaseChoice.EAGER;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${eagerId}" ${disabled}>Eager</button>`;

        var tooltip = global.parser.parse(`Give the men a show they'll never forget.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildUnfitChoice() {
        var test = ctrl.misc.strength() > 5 && ctrl.misc.endurance() > 5;
        var disabled = (ctrl.appease.has() || !test) ? "disabled" : "";
        var isSelected = ctrl.appease.get() === NightTwoLewdAppeaseChoice.UNFIT;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${unfitId}" ${disabled}>Ugly</button>`;

        var tooltip = global.parser.parse(`Surely these men can find a prettier kobold to abuse, right?`);
        if (!test) {
            tooltip = `Requires 6 strength and 6 endurance.`;
        }

        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You are: </div>`;
        choice += buildReluctantChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildUnfitChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + reluctantId), $("#" + eagerId), $("#" + unfitId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerReluctantListener() {
        $("#" + reluctantId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.appease.set(NightTwoLewdAppeaseChoice.RELUCTANT);
            loadNextPart(toReluctant);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerEagerListener() {
        $("#" + eagerId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.appease.set(NightTwoLewdAppeaseChoice.EAGER);
            loadNextPart(toEager);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerUnfitListener() {
        $("#" + unfitId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.appease.set(NightTwoLewdAppeaseChoice.UNFIT);
            loadNextPart(toUnfit);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.lewdCrude.get() !== NightTwoCrudeChoice.APPEASE) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += `</div>`;
        part += toReluctant.build();
        part += toEager.build();
        part += toUnfit.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.lewdCrude.get() !== NightTwoLewdChoice.APPEASE) {
            return;
        }

        toReluctant.registerListeners();
        toEager.registerListeners();
        toUnfit.registerListeners();

        if (ctrl.appease.has()) {
            return;
        }

        registerReluctantListener();
        registerEagerListener();
        registerUnfitListener();
    };
}

var NightTwoLewdAppeaseChoice = {
    RELUCTANT: 1,
    EAGER: 2,
    UNFIT: 3
};

